variable "env" {}
variable "domain" {}
variable "origin" {}

resource "fastly_service_v1" "sample" {
  # 設定適用後に自動で有効にしない
  #activate = false

  force_destroy = true

  # 設定名
  name = "${var.env}/${var.domain}"

  domain {
    //受け付けドメイン
    name    = "${var.domain}"
    //設定名
    comment = "${var.env}/${var.domain}"
  }

  ######################
  # バックエンド設定
  backend {
    name              = "origin"
    # オリジンアドレス
    address           = "${var.origin}"
    # オリジン問い合わせ時のホスト名を固定する
    override_host     = "${var.origin}"
  }

  ######################
  # カスタムVCL
  vcl {
    name    = "default"
    content = "${file("${path.module}/vcl/default.vcl")}"
    main    = true
  }
}

