# 7章サンプル

## ディレクトリ構成

```
.
|-- cache
|   |-- default.vcl
|   |-- default.vcl.test
|   |-- define.vcl
|   |-- ext.vcl
|   |-- health.vcl
|   |-- main.vcl
|   |-- postfilter.vcl
|   `-- prefilter.vcl
|-- gateway
|   |-- default.vcl
|   |-- default.vcl.test
|   |-- define.vcl
|   |-- ext.vcl
|   |-- health.vcl
|   |-- main.vcl
|   |-- postfilter.vcl
|   `-- prefilter.vcl
`-- test
    |-- base.vtc
    |-- cdn.example.vtc
    |-- example.vtc
    `-- test.sh

```

## 使い方

`gateway`および`cache`はそれぞれ7章のgatewayサーバー・cacheサーバーの設定となります。

`test`は今回の設定のテストコード(`*.vtc`)とそれの実行スクリプト(`test.sh`)となっています。
`test.sh`を実行することでテストコードが実行されます。
なおテストコードについてはAppendixの「テストの重要性―varnishtest」を適宜参照してください。

実サーバを作らずともテストコードを実行することで動作の確認ができますが、成功した場合は内部でどのようにヘッダが書き換えられたかなどが見えません。

```
$ ./test.sh
#    top  TEST base.vtc passed (3.348)
#    top  TEST example.vtc passed (4.585)
#    top  TEST cdn.example.vtc passed (4.618)
```

この場合`test.sh`に含まれる`varnishtest`の起動オプションに`-v`を追加することでログを見ることができます。

```
#!/bin/sh
cwd=$(cd $(dirname $0); pwd)
varnishtest -j 3 -b 1M -Dcwd="${cwd}" *.vtc
#varnishtest -v -j 3 -b 1M -Dcwd="${cwd}" *.vtc
```


## 注意事項

注意点としてVCL中のコメントにも記載しましたが、s3をオリジンとするためには[vmod_dynamic](https://github.com/nigoroll/libvmod-dynamic)を使う必要があります。
もしs3を実際に使ってテストを行う場合は環境を用意し、変更してください。

あくまでこの設定は簡易なものですが、テストと合わせていろいろ試せると思いますので、いろいろカスタマイズして使ってみてください
