vcl 4.1;

sub vcl_recv{
    //判定は1階層目で行うので2階層目では行わない
    if(req.http.x-v-cache){
        return(hash);
    }
    return(pass);
}

sub vcl_hash {
    //ユーザ情報があればキャッシュキーに含めるに含める
    if(req.http.x-v-identity){
        hash_data(req.http.x-v-identity);
    }
}

sub vcl_backend_response {
    //5章:ストレージの分割
    if(bereq.http.x-v-storage == "thumbs"){
        set beresp.storage = storage.s_thumbs;
    }elsif(bereq.http.x-v-storage == "thumbs"){
        set beresp.storage = storage.s_img;
    }else{
        set beresp.storage = storage.s_def;
    }
    //5章:TTLの取り扱い
    //50%に設定
    if(bereq.http.x-v-ttl){
        set beresp.ttl = std.duration(bereq.http.x-v-ttl, 0s) * 0.5;
        set beresp.grace = beresp.ttl;
    }
}