vcl 4.1;

import std;
import directors;

probe healthcheck_200 {
    .url               = "/healthcheck/check.html";
    .timeout           = 2s;
    .window            = 5;
    .threshold         = 3;
    .interval          = 1s;
}


backend cache01 {.probe=healthcheck_200;.host = "192.168.1.21";.port = "80";}
backend cache02 {.probe=healthcheck_200;.host = "192.168.1.22";.port = "80";}
backend cache03 {.probe=healthcheck_200;.host = "192.168.1.23";.port = "80";}

sub vcl_init{
  new l2_rand  = directors.random();
  l2_rand.add_backend(cache01, 1.0);
  l2_rand.add_backend(cache02, 1.0);
  l2_rand.add_backend(cache03, 1.0);

  new l2_cache = directors.hash();
  l2_cache.add_backend(cache01, 1.0);
  l2_cache.add_backend(cache02, 1.0);
  l2_cache.add_backend(cache03, 1.0);

}