vcl 4.1;

sub vcl_recv{
    if(req.http.x-v-cache){
        //Accept-Encodinfの正規化(gzipのみにする)
        if (req.http.Accept-Encoding ~ "gzip") {
            set req.http.Accept-Encoding = "gzip";
        } else {
            unset req.http.Accept-Encoding;
        }
        //queryの正規化(並び替え)
        set req.url = std.querysort(req.url);

        return(hash);
    }
    return(pass);
}

sub vcl_hash {
    //ユーザ情報があればキャッシュキーに含めるに含める
    if(req.http.x-v-identity){
        hash_data(req.http.x-v-identity);
    }
}

sub vcl_backend_response {
    //5章:ストレージの分割
    if(bereq.http.x-v-storage == "thumbs"){
        set beresp.storage = storage.s_thumbs;
    }elsif(bereq.http.x-v-storage == "thumbs"){
        set beresp.storage = storage.s_img;
    }else{
        set beresp.storage = storage.s_def;
    }
    //5章:TTLの取り扱い
    //80%に設定(L2=50% L1=30% Client=20%)
    if(bereq.http.x-v-ttl){
        set beresp.ttl   = std.duration(bereq.http.x-v-ttl, 0s) * 0.8;
        set beresp.grace = std.duration(bereq.http.x-v-ttl, 0s) * 0.2;
        set beresp.http.cache-control = "max-age=" + std.integer(duration=std.duration(bereq.http.x-v-ttl, 0s));
    }
}