vcl 4.1;
sub vcl_recv{
    //Hostヘッダの正規化
    if (req.http.host) {
        //Hostヘッダを小文字に揃える(lower)
        //ポート付きの形式(example.net:80)の場合はポート部を削る
        set req.http.host = regsub(req.http.host.lower(),"^([^:]+).*\z","\1");
    }

    //外部から注入されないようにunsetする
    unset req.http.x-v-identity;
    unset req.http.x-v-cache;
    unset req.http.x-v-ttl;

}



sub vcl_hash{
    //キャッシュキーにユーザ情報を含める
    if(req.http.x-v-identity){
        hash_data(req.http.x-v-identity);
    }
}

sub vcl_backend_response{
    if(bereq.http.x-v-cache){
        //set-cookieを消す
        unset beresp.http.set-cookie;
        //キャッシュするフラグを立てる
        set beresp.uncacheable = false;
    }
}